## zynaddsubfx 2.2.1

=== src/Makefile ===
include Makefile.inc

ifneq ($(MAKECMDGOALS),debug)
  CXXFLAGS= -O6 -Wall 
else 
  CXXFLAGS= -O0 -Wall -Wpointer-arith -Wstrict-prototypes
endif

CXXFLAGS += -DOS_$(OS_PORT) -D$(MIDIIN)MIDIIN -DFFTW_VERSION_$(FFTW_VERSION) -DASM_F2I_$(ASM_F2I)

ifeq ($(DISABLE_GUI),YES)
    CXXFLAGS += -DDISABLE_GUI
else
    CXXFLAGS += `fltk-config --cflags` 
endif

ifeq ($(AUDIOOUT),OSS_AND_JACK)
    CXXFLAGS += -DOSSAUDIOOUT -DJACKAUDIOOUT 
else
    CXXFLAGS += -D$(AUDIOOUT)AUDIOOUT 
endif

export CXXFLAGS

LIBS= -lm  -lmxml -lz
ifneq ($(DISABLE_GUI),YES)
    LIBS+=`fltk-config --ldflags` 
endif

ifeq ($(FFTW_VERSION),2)
LIBS += -lrfftw -lfftw
else
LIBS += -lfftw3
endif

ifeq ($(OS_PORT),LINUX) 
LIBS+= -lpthread
else
#dynamic linking
#LIBS+= -lpthreadGC
#static linking
LIBS+= /usr/lib/libpthreadGC1.a
endif

ifeq ($(MIDIIN),ALSA) 
LIBS+= -lasound
endif

ifeq ($(AUDIOOUT),PA) 
LIBS+= -lportaudio
endif

ifeq ($(OS_PORT),WINDOWS) 
LIBS+= -lwinmm
endif


ifeq ($(AUDIOOUT),OSS_AND_JACK) 
CXXFLAGS += `pkg-config --cflags jack`
LIBS+= `pkg-config --libs jack`
endif

ifeq ($(AUDIOOUT),JACK) 
CXXFLAGS += `pkg-config --cflags jack`
LIBS+= `pkg-config --libs jack`
endif

ifeq ($(AUDIOOUT),JACK_RT) 
CXXFLAGS += `pkg-config --cflags jack`
LIBS+= `pkg-config --libs jack`
endif

objects=main.o
SUBDIRS=DSP Effects Input Misc Output Params Synth Seq

.PHONY: subdirs $(SUBDIRS)

all:
#	yes " " | head

	$(MAKE) -C UI $@
#	@sh -c "cd UI ; $(CXX) -MM -MG -w *.cc >> ../Make.deps ; cd .."
	@for name in $(SUBDIRS); do sh -c "cd $$name ; $(CXX) -MM -MG -w *.C >> ../Make.deps ; cd .."; done
	$(MAKE) subdirs
	$(MAKE) objs
	rm -f zynaddsubfx zynaddsubfx.exe
	rm -f Make.deps 


ifeq ($(AUDIOOUT),DSSI) 
	$(CXX) -shared  -o zynaddsubfx.so */*.o *.o $(LIBS) 
else
ifeq ($(AUDIOOUT),VST) 
	$(CXX) -shared -o zynaddsubfx_vst.dll */*.o *.o ../../vstsdk2/source/common/AudioEffect.cpp ../../vstsdk2/source/common/audioeffectx.cpp  $(LIBS) zynaddsubfx_gcc.def
else


ifeq ($(OS_PORT),LINUX) 
	$(CXX) -o zynaddsubfx */*.o *.o $(LIBS)
else
	$(CXX) -o zynaddsubfx.exe */*.o *.o $(LIBS)
endif 
endif
endif

subdirs: $(SUBDIRS)

$(SUBDIRS):
	$(MAKE) -C $@


objs:$(objects)

debug: all

main.o:Misc/Master.h Misc/Util.h Output/OSSaudiooutput.h\
       Input/OSSMidiIn.h Input/ALSAMidiIn.h
       

.PHONY : clean
clean: 
	rm -f $(objects) zynaddsubfx zynaddsubfx_vst.dll zynaddsubfx.exe zynaddsubfx.so
	@for name in $(SUBDIRS); do sh -c "make -C $$name $@"; done
	rm -f Make.deps
	rm -f */*.o *.o
	$(MAKE) -C UI $@

=== src/Misc/Makefile ===
include ../Makefile.inc

objects=Bank.o Master.o Microtonal.o Part.o Util.o Config.o Dump.o XMLwrapper.o


all: $(objects)

-include ../Make.deps

.PHONY : clean
clean: 
	rm -f $(objects)
	rm -f makeinclude.deps

=== src/Output/Makefile ===
include ../Makefile.inc

objects=Recorder.o 

ifeq ($(AUDIOOUT),OSS_AND_JACK)
objects+=OSSaudiooutput.o JACKaudiooutput.o
endif

ifeq ($(AUDIOOUT),JACK)
objects+=JACKaudiooutput.o
endif

ifeq ($(AUDIOOUT),DSSI)
objects+=DSSIaudiooutput.o
endif

ifeq ($(AUDIOOUT),JACK_RT)
objects+=JACK_RTaudiooutput.o
endif

ifeq ($(AUDIOOUT),PA)
objects+=PAaudiooutput.o
endif

ifeq ($(AUDIOOUT),OSS)
objects+=OSSaudiooutput.o
endif

ifeq ($(AUDIOOUT),VST)
objects+=VSTaudiooutput.o
endif


all: $(objects)

-include ../Make.deps

.PHONY : clean
clean: 
	rm -f $(objects)
	rm -f makeinclude.deps

## zynaddsubfx 2.4.0

=== src/Makefile ===
--- 
+++ 
@@ -1,17 +1,17 @@
 include Makefile.inc
 
 ifneq ($(MAKECMDGOALS),debug)
-  CXXFLAGS= -O6 -Wall 
+  CXXFLAGS= -O6 -Wall -g 
 else 
-  CXXFLAGS= -O0 -Wall -Wpointer-arith -Wstrict-prototypes
+  CXXFLAGS= -O0 -Wall -Wpointer-arith 
 endif
 
-CXXFLAGS += -DOS_$(OS_PORT) -D$(MIDIIN)MIDIIN -DFFTW_VERSION_$(FFTW_VERSION) -DASM_F2I_$(ASM_F2I)
+CXXFLAGS += -DOS_$(OS_PORT) -D$(MIDIIN)MIDIIN -DFFTW_VERSION_$(FFTW_VERSION) -DASM_F2I_$(ASM_F2I) -ggdb
 
 ifeq ($(DISABLE_GUI),YES)
     CXXFLAGS += -DDISABLE_GUI
 else
-    CXXFLAGS += `fltk-config --cflags` 
+    CXXFLAGS += -DFLTK_GUI `fltk-config --cflags` 
 endif
 
 ifeq ($(AUDIOOUT),OSS_AND_JACK)
@@ -70,8 +70,14 @@
 LIBS+= `pkg-config --libs jack`
 endif
 
+ifeq ($(LINUX_USE_LASH),YES)
+CXXFLAGS += `pkg-config --cflags lash-1.0` -DUSE_LASH
+LIBS+= `pkg-config --libs lash-1.0`
+endif
+
+
 objects=main.o
-SUBDIRS=DSP Effects Input Misc Output Params Synth Seq
+SUBDIRS=Controls DSP Effects Input Misc Output Params Samples Synth Seq
 
 .PHONY: subdirs $(SUBDIRS)
 
@@ -80,7 +86,7 @@
 
 	$(MAKE) -C UI $@
 #	@sh -c "cd UI ; $(CXX) -MM -MG -w *.cc >> ../Make.deps ; cd .."
-	@for name in $(SUBDIRS); do sh -c "cd $$name ; $(CXX) -MM -MG -w *.C >> ../Make.deps ; cd .."; done
+	@for name in $(SUBDIRS); do sh -c "cd $$name ; $(CXX) -MM -MG -w *.cpp >> ../Make.deps ; cd .."; done
 	$(MAKE) subdirs
 	$(MAKE) objs
 	rm -f zynaddsubfx zynaddsubfx.exe
@@ -123,5 +129,6 @@
 	@for name in $(SUBDIRS); do sh -c "make -C $$name $@"; done
 	rm -f Make.deps
 	rm -f */*.o *.o
+	rm -f ./*/*~ ./*~
 	$(MAKE) -C UI $@

=== src/Controls/Makefile ===
include ../Makefile.inc

objects=Control.o DelayCtl.o


all: $(objects)

-include ../Make.deps

.PHONY : clean
clean: 
	rm -f $(objects)
	rm -f makeinclude.deps

=== src/DSP/Makefile ===
include ../Makefile.inc

objects=FFTwrapper.o AnalogFilter.o FormantFilter.o SVFilter.o Filter.o


all: $(objects)

-include ../Make.deps

.PHONY : clean
clean: 
	rm -f $(objects)
	rm -f makeinclude.deps

=== src/Effects/Makefile ===
include ../Makefile.inc

objects=Alienwah.o Chorus.o Echo.o Effect.o \
        EffectLFO.o EffectMgr.o Phaser.o Reverb.o \
        Distorsion.o EQ.o DynamicFilter.o


all: $(objects)

-include ../Make.deps

.PHONY : clean
clean: 
	rm -f $(objects)
	rm -f makeinclude.deps

=== src/Input/Makefile ===
include ../Makefile.inc

objects=NULLMidiIn.o MidiIn.o

ifeq ($(MIDIIN),ALSA) 
objects+=ALSAMidiIn.o 
endif

ifeq ($(MIDIIN),OSS) 
objects+=OSSMidiIn.o 
endif

ifeq ($(MIDIIN),WIN) 
objects+=WINMidiIn.o 
endif


all: $(objects)

-include ../Make.deps

.PHONY : clean
clean: 
	rm -f $(objects)
	rm -f makeinclude.deps

=== src/Misc/Makefile ===
--- 
+++ 
@@ -1,6 +1,10 @@
 include ../Makefile.inc
 
 objects=Bank.o Master.o Microtonal.o Part.o Util.o Config.o Dump.o XMLwrapper.o
+
+ifeq ($(LINUX_USE_LASH),YES)
+objects += LASHClient.o
+endif
 
 
 all: $(objects)

=== src/Output/Makefile ===
--- 
+++ 
@@ -1,6 +1,6 @@
 include ../Makefile.inc
 
-objects=Recorder.o 
+objects=Recorder.o WAVaudiooutput.o
 
 ifeq ($(AUDIOOUT),OSS_AND_JACK)
 objects+=OSSaudiooutput.o JACKaudiooutput.o

=== src/Params/Makefile ===
include ../Makefile.inc

objects=ADnoteParameters.o EnvelopeParams.o FilterParams.o \
        LFOParams.o SUBnoteParameters.o PADnoteParameters.o Controller.o Presets.o PresetsStore.o


all: $(objects)

-include ../Make.deps

.PHONY : clean
clean: 
	rm -f $(objects)
	rm -f makeinclude.deps

=== src/Samples/Makefile ===
include ../Makefile.inc

objects=Sample.o AuSample.o FqSample.o


all: $(objects)

-include ../Make.deps

.PHONY : clean
clean: 
	rm -f $(objects)
	rm -f makeinclude.deps

=== src/Seq/Makefile ===
include ../Makefile.inc

objects=MIDIEvents.o MIDIFile.o Sequencer.o


all: $(objects)

-include ../Make.deps

.PHONY : clean
clean: 
	rm -f $(objects)
	rm -f makeinclude.deps

=== src/Synth/Makefile ===
include ../Makefile.inc

objects=ADnote.o Envelope.o LFO.o OscilGen.o SUBnote.o Resonance.o PADnote.o


all: $(objects)

-include ../Make.deps

.PHONY : clean
clean: 
	rm -f $(objects)
	rm -f makeinclude.deps

=== src/UI/Makefile ===
include ../Makefile.inc

%.cc  : %.fl
	fluid -c $<

objects=WidgetPDial.o PresetsUI.o EnvelopeUI.o LFOUI.o FilterUI.o VirKeyboard.o ConfigUI.o\
	SUBnoteUI.o ResonanceUI.o OscilGenUI.o ADnoteUI.o PADnoteUI.o EffUI.o BankUI.o \
	PartUI.o MicrotonalUI.o SeqUI.o MasterUI.o 
ifeq ($(DISABLE_GUI),YES)
    objects=
endif

all: $(objects)

WidgetPDial.o: WidgetPDial.fl WidgetPDial.cc WidgetPDial.h
PresetsUI.o: PresetsUI.fl PresetsUI.cc PresetsUI.h
EnvelopeUI.o: EnvelopeUI.fl EnvelopeUI.cc EnvelopeUI.h
LFOUI.o: LFOUI.fl LFOUI.cc LFOUI.h
FilterUI.o: FilterUI.fl FilterUI.cc FilterUI.h

ResonanceUI.o:ResonanceUI.fl ResonanceUI.cc ResonanceUI.h
OscilGenUI.o:OscilGenUI.fl OscilGenUI.cc OscilGenUI.h
ADnoteUI.o:ADnoteUI.fl ADnoteUI.cc ADnoteUI.h
SUBnoteUI.o:SUBnoteUI.fl SUBnoteUI.cc SUBnoteUI.h
PADnoteUI.o:PADnoteUI.fl PADnoteUI.cc PADnoteUI.h

EffUI.o: EffUI.fl EffUI.cc EffUI.h
BankUI.o: BankUI.fl BankUI.cc BankUI.h
PartUI.o: PartUI.fl PartUI.cc PartUI.h

VirKeyboard.o:  VirKeyboard.fl VirKeyboard.cc VirKeyboard.h
ConfigUI.o: ConfigUI.fl ConfigUI.cc ConfigUI.h
MicrotonalUI.o: MicrotonalUI.fl MicrotonalUI.cc MicrotonalUI.h
SeqUI.o: SeqUI.fl SeqUI.cc SeqUI.h
MasterUI.o:  MasterUI.fl MasterUI.cc MasterUI.h

.PHONY : clean
clean: 
	rm -f $(objects)
	rm -f makeinclude.deps
	rm -f *.h *.cc

## zynaddsubfx 2.4.3

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8)
set(CMAKE_MODULE_PATH "${CMAKE_SOURCE_DIR}/cmake/")
project(zynaddsubfx)
set(VERSION "2.4.3")

enable_testing()
include(CTestConfig.cmake)
#Currently the only directory that uses cmake
add_subdirectory(src)

install(FILES AUTHORS.txt COPYING FAQ.txt HISTORY.txt README.txt
	DESTINATION share/doc/zynaddsubfx
	)

=== doc/Makefile ===

.PHONY: subdirs gen

all: gen-files man xhtml chunked pdf

gen-files:
	cd gen; make


xhtml: zynaddsubfx.txt envelope.txt intro.txt lfo.txt
	asciidoc -a numbered -a toc -b html5 \
		zynaddsubfx.txt

chunked:
	asciidoc --doctype=article   -b docbook \
	          zynaddsubfx.txt
	rm -rf ./zynaddsubfx.chunked
	mkdir ./zynaddsubfx.chunked
	rm -f "./zynaddsubfx.chunked/*.html"
	ln -s ../images/ zynaddsubfx.chunked/images
	xsltproc --stringparam html.stylesheet "./docbook-xsl.css" \
	         --stringparam callout.graphics 0 \
		 --stringparam navig.graphics 0 \
		 --stringparam admon.textlabel 1 \
		 --stringparam admon.graphics 0 \
		 --nonet \
	         --stringparam base.dir "zynaddsubfx.chunked/" \
	         "/etc/asciidoc/docbook-xsl/chunked.xsl" \
		 "./zynaddsubfx.xml" \

pdf:
	a2x -f pdf zynaddsubfx.txt

man: zynaddsubfx.1.txt
	a2x -f manpage zynaddsubfx.1.txt

clean:
	rm -f *~ *html *pdf *xml *tex *log zynaddsubfx.chunked/images
	rm -r -f zynaddsubfx.chunked/

=== src/CMakeLists.txt ===
#checking include/library paths
message(STATUS "Checking Include Path" $ENV{CMAKE_INCLUDE_PATH} ${CMAKE_INCLUDE_PATH})
message(STATUS "Checking Library Path" $ENV{CMAKE_LIBRARY_PATH} ${CMAKE_LIBRARY_PATH})

#Dependency check
find_package(PkgConfig REQUIRED)
find_package(zlib REQUIRED)
pkg_check_modules(FFTW REQUIRED fftw3)
pkg_check_modules(MXML REQUIRED mxml)
find_package(Threads   REQUIRED)
find_package(OSS)
find_package(Alsa)
pkg_check_modules(JACK jack)
pkg_check_modules(PORTAUDIO portaudio-2.0>=19)
set(FLTK_SKIP_OPENGL true)
find_package(FLTK)
find_package(OpenGL) #for FLTK
find_package(CxxTest)
# lash
pkg_search_module(LASH lash-1.0)
mark_as_advanced(LASH_LIBRARIES)
pkg_search_module(DSSI dssi>=0.9.0)
mark_as_advanced(DSSI_LIBRARIES)
pkg_search_module(LIBLO liblo>=0.26)
mark_as_advanced(LIBLO_LIBRARIES)

######### Settings ###########
# NOTE: These cache variables should normally not be changed in this
# file, but either in in CMakeCache.txt before compile, or by passing
# parameters directly into cmake using the -D flag.
SET (GuiModule fltk CACHE STRING "GUI module, either fltk, qt or off")
SET (CompileTests ${CXXTEST_FOUND} CACHE BOOL "whether tests should be compiled in or not")
SET (AlsaEnable ${ALSA_FOUND} CACHE BOOL
    "Enable support for Advanced Linux Sound Architecture")
SET (JackEnable ${JACK_FOUND} CACHE BOOL
    "Enable support for JACK Audio Connection toolKit")
SET (OssEnable ${OSS_FOUND} CACHE BOOL
    "Enable support for Open Sound System")
SET (PaEnable ${PORTAUDIO_FOUND} CACHE BOOL
    "Enable support for Port Audio System")
SET (LashEnable ${LASH_FOUND} CACHE BOOL
    "Enable LASH Audio Session Handler")
SET (DssiEnable ${DSSI_FOUND} CACHE BOOL
    "Enable DSSI Plugin compilation")
SET (LibloEnable ${LIBLO_FOUND} CACHE BOOL
    "Enable Liblo")

# Now, handle the incoming settings and set define flags/variables based
# on this

# Add version information
add_definitions(-DVERSION="${VERSION}")

# Give a good guess on the best Input/Output default backends
if (JackEnable)
    SET (DefaultOutput jack CACHE STRING
        "Default Output module: [null, alsa, oss, jack, portaudio]")
    # Override with perhaps more helpful midi backends
    if (AlsaEnable)
        SET (DefaultInput alsa CACHE STRING
            "Default Input module: [null, alsa, oss, jack]")
    elseif (OssEnable)
        SET (DefaultInput oss CACHE STRING
            "Default Input module: [null, alsa, oss, jack]")
    else ()
        SET (DefaultInput jack CACHE STRING
            "Default Input module: [null, alsa, oss, jack]")
    endif ()
elseif (AlsaEnable)
    SET (DefaultOutput alsa CACHE STRING
        "Default Output module: [null, alsa, oss, jack, portaudio]")
    SET (DefaultInput alsa CACHE STRING
        "Default Input module: [null, alsa, oss, jack]")
elseif (OssEnable)
    SET (DefaultOutput oss CACHE STRING
        "Default Output module: [null, alsa, oss, jack, portaudio]")
    SET (DefaultInput oss CACHE STRING
        "Default Input module: [null, alsa, oss, jack]")
else()
    SET (DefaultOutput null CACHE STRING
        "Default Output module: [null, alsa, oss, jack, portaudio]")
    SET (DefaultInput null CACHE STRING
        "Default Input module: [null, alsa, oss, jack]")
endif()



if (GuiModule STREQUAL qt AND QT_FOUND)
	set (QtGui TRUE)
elseif(GuiModule STREQUAL fltk AND FLTK_FOUND)
	set (FltkGui TRUE)
elseif(GuiModule STREQUAL off)
        add_definitions(-DDISABLE_GUI)
else  ()
        set (GuiModule off CACHE STRING "GUI module, either fltk, qt or off")
        add_definitions(-DDISABLE_GUI)
	message(STATUS "GUI module defaulting to off")
endif()


#Build Flags
option (BuildForAMD_X86_64 "Build for AMD x86_64 system" OFF)
option (BuildForCore2_X86_64 "Build for Intel Core2 x86_64 system" OFF)
option (BuildForDebug "Include gdb debugging support" OFF)

set(CMAKE_BUILD_TYPE "Release")

set (BuildOptions_x86_64AMD
    "-O3 -march=athlon64 -m64 -Wall -ffast-math -fno-finite-math-only -fomit-frame-pointer"
  CACHE STRING "X86_64 compiler options"
)

set (BuildOptions_X86_64Core2
    "-O3 -march=core2 -m64 -Wall -ffast-math -fno-finite-math-only -fomit-frame-pointer"
  CACHE STRING "X86_64 compiler options"
)

set (BuildOptionsBasic
    "-O3 -msse -msse2 -mfpmath=sse -ffast-math -fomit-frame-pointer"
    CACHE STRING "basic X86 complier options"
)

set (BuildOptionsDebug
    "-O0 -g3 -ggdb -Wall -Wpointer-arith" CACHE STRING "Debug build flags")

########### Settings dependant code ###########
# From here on, the setting variables have  been prepared so concentrate
# on the actual compiling.

if(AlsaEnable)
	list(APPEND AUDIO_LIBRARIES ${ASOUND_LIBRARY})
	list(APPEND AUDIO_LIBRARY_DIRS ${ASOUND_LIBRARY_DIRS})
	add_definitions(-DALSA=1)
endif(AlsaEnable)

if(JackEnable)
	list(APPEND AUDIO_LIBRARIES ${JACK_LIBRARIES})
	list(APPEND AUDIO_LIBRARY_DIRS ${JACK_LIBRARY_DIRS})
	add_definitions(-DJACK=1)
endif(JackEnable)

if(OssEnable)
	add_definitions(-DOSS=1)
endif(OssEnable)

if(PaEnable)
	include_directories(${PORTAUDIO_INCLUDE_DIR})
	add_definitions(-DPORTAUDIO=1)
	list(APPEND AUDIO_LIBRARIES ${PORTAUDIO_LIBRARIES})
	list(APPEND AUDIO_LIBRARY_DIRS ${PORTAUDIO_LIBRARY_DIRS})
endif()

if (CompileTests)
	ENABLE_TESTING()
endif()

if(LashEnable)
	include_directories(${LASH_INCLUDE_DIRS})
	add_definitions(-DLASH=1)
	list(APPEND AUDIO_LIBRARIES ${LASH_LIBRARIES})
	list(APPEND AUDIO_LIBRARY_DIRS ${LASH_LIBRARY_DIRS})
	message(STATUS "Compiling with lash")
endif()
if(LibloEnable)
	include_directories(${LIBLO_INCLUDE_DIRS})
	add_definitions(-DUSE_NSM=1)
	list(APPEND AUDIO_LIBRARIES ${LIBLO_LIBRARIES})
	list(APPEND AUDIO_LIBRARY_DIRS ${LIBLO_LIBRARY_DIRS})
	message(STATUS "Compiling with liblo")
endif()

# other include directories
include_directories(${ZLIB_INCLUDE_DIRS} ${MXML_INCLUDE_DIRS})

add_definitions(
	 -DASM_F2I_YES
	 -g #TODO #todo put in a better location
	 -Wall
	 -Wextra
	 )

if (BuildForDebug)
	set (CMAKE_BUILD_TYPE "Debug")
	set (CMAKE_CXX_FLAGS_DEBUG ${BuildOptionsDebug})
	message (STATUS "Building for ${CMAKE_BUILD_TYPE}, flags: ${CMAKE_CXX_FLAGS_DEBUG}")
else (BuildForDebug)
	set (CMAKE_BUILD_TYPE "Release")
	if (BuildForAMD_X86_64)
		set (CMAKE_CXX_FLAGS_RELEASE ${BuildOptions_x86_64AMD})
	else (BuildForAMD_X86_64)
		if (BuildForCore2_X86_64)
			set (CMAKE_CXX_FLAGS_RELEASE ${BuildOptions_X86_64Core2})
		else (BuildForCore2_X86_64)
			set (CMAKE_CXX_FLAGS_RELEASE ${BuildOptionsBasic})
		endif (BuildForCore2_X86_64)
	endif (BuildForAMD_X86_64)
	message (STATUS "Building for ${CMAKE_BUILD_TYPE}, flags: ${CMAKE_CXX_FLAGS_RELEASE}")
endif (BuildForDebug)

add_definitions(-fPIC)

if(FLTK_FOUND)
	mark_as_advanced(FORCE FLTK_BASE_LIBRARY)
	mark_as_advanced(FORCE FLTK_CONFIG_SCRIPT)
	mark_as_advanced(FORCE FLTK_DIR)
	mark_as_advanced(FORCE FLTK_FLUID_EXECUTABLE)
	mark_as_advanced(FORCE FLTK_FORMS_LIBRARY)
	mark_as_advanced(FORCE FLTK_GL_LIBRARY)
	mark_as_advanced(FORCE FLTK_IMAGES_LIBRARY)
	mark_as_advanced(FORCE FLTK_INCLUDE_DIR)
	mark_as_advanced(FORCE FLTK_MATH_LIBRARY)
endif(FLTK_FOUND)

if(FltkGui)
	#UGLY WORKAROUND
	find_program (MYFLTK_CONFIG fltk-config)
	if (MYFLTK_CONFIG)
		execute_process (COMMAND ${MYFLTK_CONFIG} --ldflags OUTPUT_VARIABLE MYFLTK_LDFLAGS)
		string(STRIP ${MYFLTK_LDFLAGS} MYFLTK_LIBRARIES)
	endif()

	message(STATUS ${MYFLTK_LDFLAGS})


	set(GUI_LIBRARIES ${FLTK_LIBRARIES} ${MYFLTK_LIBRARIES} ${OPENGL_LIBRARIES} zynaddsubfx_gui)

	add_definitions(-DFLTK_GUI)

	message(STATUS "Will build fltk gui")

	include_directories(
			${FLTK_INCLUDE_DIR}
			"${CMAKE_CURRENT_SOURCE_DIR}/UI"
			"${CMAKE_CURRENT_BINARY_DIR}/UI"
			)

	add_subdirectory(UI)
endif()

########### General section ##############
# Following this should be only general compilation code, and no mention
# of module-specific variables

link_directories(${AUDIO_LIBRARY_DIRS} ${ZLIB_LIBRARY_DIRS} ${FFTW_LIBRARY_DIRS} ${MXML_LIBRARY_DIRS} ${FLTK_LIBRARY_DIRS})

include_directories(
	${CMAKE_CURRENT_SOURCE_DIR}
	${CMAKE_CURRENT_BINARY_DIR}
	)



set(NONGUI_LIBRARIES
	zynaddsubfx_misc
	zynaddsubfx_synth
	zynaddsubfx_effect
	zynaddsubfx_params
	zynaddsubfx_dsp
	zynaddsubfx_nio
	)

add_subdirectory(Misc)
add_subdirectory(Synth)
add_subdirectory(Effects)
add_subdirectory(Params)
add_subdirectory(DSP)
if(CompileTests)
	add_subdirectory(Tests)
endif(CompileTests)
add_subdirectory(Nio)

set(zynaddsubfx_SRCS
	main.cpp
	)

message(STATUS "using link directories: ${AUDIO_LIBRARY_DIRS} ${ZLIB_LIBRARY_DIRS} ${FFTW_LIBRARY_DIRS} ${MXML_LIBRARY_DIRS} ${FLTK_LIBRARY_DIRS}")


add_executable(zynaddsubfx
	${zynaddsubfx_SRCS}
)

target_link_libraries(zynaddsubfx
	${NONGUI_LIBRARIES}
	${GUI_LIBRARIES}
	${ZLIB_LIBRARIES}
	${FFTW_LIBRARIES}
	${MXML_LIBRARIES}
	${NIO_LIBRARIES}
	${AUDIO_LIBRARIES}
	${OS_LIBRARIES}
	pthread
	)

if (DssiEnable)
	add_library(zynaddsubfx_dssi SHARED
		Output/DSSIaudiooutput.cpp
		)

	target_link_libraries(zynaddsubfx_dssi
		${NONGUI_LIBRARIES}
		${ZLIB_LIBRARIES}
		${FFTW_LIBRARY}
        ${MXML_LIBRARIES}
		${NIO_LIBRARIES}
		${AUDIO_LIBRARIES}
		${OS_LIBRARIES}
		)
	if (${CMAKE_SIZEOF_VOID_P} EQUAL "8")
		install(TARGETS zynaddsubfx_dssi LIBRARY DESTINATION lib64/dssi/)
	else ()
		install(TARGETS zynaddsubfx_dssi LIBRARY DESTINATION lib/dssi/)
	endif ()
endif()

message(STATUS "Link libraries: ${ZLIB_LIBRARY} ${FFTW_LIBRARY} ${MXML_LIBRARIES} ${AUDIO_LIBRARIES} ${OS_LIBRARIES}")
install(TARGETS zynaddsubfx
	RUNTIME DESTINATION bin
	)

include(CTest)

=== ExternalPrograms/Controller/Makefile ===
controller: main.o Controller.o ControllerUI.o
	gcc -o controller *.o `fltk-config --ldflags` -lasound -lpthread -lm -lstdc++

ControllerUI.cxx ControllerUI.h: ControllerUI.fl
	fluid -c ControllerUI.fl

ControllerUI.o: ControllerUI.cxx ControllerUI.h
	gcc `fltk-config --cflags` -c ControllerUI.cxx -o ControllerUI.o

Controller.o: Controller.C Controller.h
	gcc `fltk-config --cflags` -c Controller.C -o Controller.o

main.o: main.C Controller.h ControllerUI.h
	gcc `fltk-config --cflags` -c main.C -o main.o

clean:
	rm -f *.o controller ControllerUI.cxx ControllerUI.h

=== ExternalPrograms/Spliter/Makefile ===
spliter: main.o Spliter.o SpliterUI.o
	gcc -o spliter *.o `fltk-config --ldflags` -lasound -lstdc++

SplitterUI.cxx SpliterUI.h: SpliterUI.fl
	fluid -c SpliterUI.fl

SpliterUI.o: SplitterUI.cxx SpliterUI.h
	gcc -g `fltk-config --cflags` -c SpliterUI.cxx -o SpliterUI.o

Spliter.o: Spliter.C Spliter.h
	gcc -g `fltk-config --cflags` -c Spliter.C -o Spliter.o

main.o: main.C Spliter.h SpliterUI.h
	gcc -g `fltk-config --cflags` -c main.C -o main.o

clean:
	rm -f *.o spliter SpliterUI.cxx SpliterUI.h

=== src/DSP/CMakeLists.txt ===
set(zynaddsubfx_dsp_SRCS
	AnalogFilter.cpp
	FFTwrapper.cpp
	Filter.cpp
	FormantFilter.cpp
	SVFilter.cpp
        Unison.cpp
)

add_library(zynaddsubfx_dsp STATIC
	${zynaddsubfx_dsp_SRCS} 
	)

target_link_libraries(zynaddsubfx_dsp)

=== src/Misc/CMakeLists.txt ===
include_directories(${MXML_INCLUDE_DIR})

set(zynaddsubfx_misc_SRCS
	Bank.cpp
	Config.cpp
	Dump.cpp
	Master.cpp
	Microtonal.cpp
	Part.cpp
	Util.cpp
	XMLwrapper.cpp
	Recorder.cpp
	WavFile.cpp
	WaveShapeSmps.cpp
)



if(LashEnable)
    set(zynaddsubfx_misc_SRCS ${zynaddsubfx_misc_SRCS} LASHClient.cpp)
endif()

add_library(zynaddsubfx_misc STATIC
	${zynaddsubfx_misc_SRCS}
	)

target_link_libraries(zynaddsubfx_misc zynaddsubfx_nio)

=== src/Nio/CMakeLists.txt ===
#Defaults:
#         - Wave Output (enabled with the record function)
#         - Null Output
#         - Null Output Running by default
#         - Managed with OutMgr
set(zynaddsubfx_nio_SRCS
    WavEngine.cpp
    NulEngine.cpp
    AudioOut.cpp
    MidiIn.cpp
    OutMgr.cpp
    InMgr.cpp
    Engine.cpp
    EngineMgr.cpp
    Nio.cpp
    )

set(zynaddsubfx_nio_lib )

add_definitions(-DOUT_DEFAULT="${DefaultOutput}")
add_definitions(-DIN_DEFAULT="${DefaultInput}")

if(JackEnable)
    include_directories(${JACK_INCLUDE_DIR})
    list(APPEND zynaddsubfx_nio_SRCS JackEngine.cpp)
    list(APPEND zynaddsubfx_nio_lib ${JACK_LIBRARIES})
endif(JackEnable)

if(PaEnable)
    include_directories(${PORTAUDIO_INCLUDE_DIR})
    list(APPEND zynaddsubfx_nio_SRCS PaEngine.cpp)
    list(APPEND zynaddsubfx_nio_lib ${PORTAUDIO_LIBRARIES})
endif(PaEnable)

if(AlsaEnable)
    list(APPEND zynaddsubfx_nio_SRCS AlsaEngine.cpp)
    list(APPEND zynaddsubfx_nio_lib ${ASOUND_LIBRARY})
endif(AlsaEnable)

if(OssEnable)
    list(APPEND zynaddsubfx_nio_SRCS OssEngine.cpp)
endif(OssEnable)


add_library(zynaddsubfx_nio STATIC
    ${zynaddsubfx_nio_SRCS} 
    )

target_link_libraries(zynaddsubfx_nio zynaddsubfx_misc) #for WavFile

=== src/Params/CMakeLists.txt ===
set(zynaddsubfx_params_SRCS
	ADnoteParameters.cpp
	Controller.cpp
	EnvelopeParams.cpp
	FilterParams.cpp
	LFOParams.cpp
	PADnoteParameters.cpp
	Presets.cpp
	PresetsArray.cpp
	PresetsStore.cpp
	SUBnoteParameters.cpp

)

add_library(zynaddsubfx_params STATIC
	${zynaddsubfx_params_SRCS} 
	)

target_link_libraries(zynaddsubfx_params zynaddsubfx_misc)

=== src/Synth/CMakeLists.txt ===
set(zynaddsubfx_synth_SRCS
	SynthNote.cpp
	ADnote.cpp
	Envelope.cpp
	LFO.cpp
	OscilGen.cpp
	PADnote.cpp
	Resonance.cpp
	SUBnote.cpp
)

add_library(zynaddsubfx_synth STATIC
	${zynaddsubfx_synth_SRCS} 
	)

target_link_libraries(zynaddsubfx_synth)

=== src/Tests/CMakeLists.txt ===
#for tests looking for files stored in the source dir
add_definitions(-DSOURCE_DIR="${CMAKE_CURRENT_SOURCE_DIR}")

CXXTEST_ADD_TEST(ControllerTest ControllerTest.cpp ${CMAKE_CURRENT_SOURCE_DIR}/ControllerTest.h)
CXXTEST_ADD_TEST(EchoTest EchoTest.cpp ${CMAKE_CURRENT_SOURCE_DIR}/EchoTest.h)
#CXXTEST_ADD_TEST(SampleTest SampleTest.h)
CXXTEST_ADD_TEST(MicrotonalTest MicrotonalTest.cpp ${CMAKE_CURRENT_SOURCE_DIR}/MicrotonalTest.h)
CXXTEST_ADD_TEST(XMLwrapperTest XMLwrapper.cpp ${CMAKE_CURRENT_SOURCE_DIR}/XMLwrapperTest.h)
CXXTEST_ADD_TEST(ADnoteTest AdNoteTest.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/AdNoteTest.h)
CXXTEST_ADD_TEST(SUBnoteTest SubNoteTest.cpp ${CMAKE_CURRENT_SOURCE_DIR}/SubNoteTest.h)
CXXTEST_ADD_TEST(OscilGenTest OscilGenTest.cpp ${CMAKE_CURRENT_SOURCE_DIR}/OscilGenTest.h)
CXXTEST_ADD_TEST(RandTest RandTest.cpp ${CMAKE_CURRENT_SOURCE_DIR}/RandTest.h)

set(test_lib ${NONGUI_LIBRARIES} ${ZLIB_LIBRARY} ${FFTW_LIBRARIES} ${MXML_LIBRARIES} pthread)
message(STATUS "Linking tests with: ${test_lib}")
target_link_libraries(ADnoteTest     ${test_lib})
target_link_libraries(SUBnoteTest    ${test_lib})
target_link_libraries(ControllerTest ${test_lib})
target_link_libraries(EchoTest       ${test_lib})
target_link_libraries(MicrotonalTest ${test_lib})
target_link_libraries(OscilGenTest   ${test_lib})
target_link_libraries(XMLwrapperTest ${test_lib})
target_link_libraries(RandTest       ${test_lib})

=== src/UI/CMakeLists.txt ===
set(UI_fl_files
    ADnoteUI.fl
    BankUI.fl
    ConfigUI.fl
    EffUI.fl
    EnvelopeUI.fl
    FilterUI.fl
    LFOUI.fl
    MasterUI.fl
    MicrotonalUI.fl
    OscilGenUI.fl
    PADnoteUI.fl
    PartUI.fl
    PresetsUI.fl
    ResonanceUI.fl
    SUBnoteUI.fl
    VirKeyboard.fl
)

include_directories(${CMAKE_CURRENT_BINARY_DIR})

set_source_files_properties(UI/MasterUI.h PROPERTIES GENERATED 1)
fltk_wrap_ui(zynaddsubfx_gui ${UI_fl_files})

if(LibloEnable)
    set(zynaddsubfx_gui_FLTK_UI_SRCS ${zynaddsubfx_gui_FLTK_UI_SRCS} NSM.C NSM/Client.C)
endif()

add_library(zynaddsubfx_gui STATIC
	${UI_objs}
	${zynaddsubfx_gui_FLTK_UI_SRCS}
        NioUI.cpp
        WidgetPDial.cpp
	)

target_link_libraries(zynaddsubfx_gui ${FLTK_LIBRARIES} ${MYFLTK_LIBRARIES})

=== debian/changelog ===
zynaddsubfx (2.4.3-5) unstable; urgency=medium

  * Team upload.
  * Don't ship anything in /usr/lib64. (Closes: #787919)
  * Avoid shipping upstream changelog twice.
  * Bump Standards.

 -- Alessio Treglia <alessio@debian.org>  Sun, 07 Jun 2015 00:44:45 +0100

zynaddsubfx (2.4.3-4) unstable; urgency=low

  * Bump Standards.
  * Add VCS canonical URLs.

 -- Jaromír Mikeš <mira.mikes@seznam.cz>  Thu, 09 May 2013 16:02:36 +0200

zynaddsubfx (2.4.3-3) experimental; urgency=low

  * Team upload.
  * Stop forcing SSE and x86 compiler options in the generic target.
  * Add patch to fix small misspellings.
  * Enable parallel builds.

 -- Alessio Treglia <alessio@debian.org>  Tue, 27 Nov 2012 01:39:14 +0000

zynaddsubfx (2.4.3-2) experimental; urgency=low

  * Added dssi-dev and liblo-dev as dependency
  * Introduced zynaddsubfx-dssi package (Closes: #629194)

 -- Jaromír Mikeš <mira.mikes@seznam.cz>  Sat, 01 Sep 2012 12:17:59 +0200

zynaddsubfx (2.4.3-1) experimental; urgency=low

  [ Jaromír Mikeš ]
  * New upstream release
  * Taking over package with agreement of Eduardo Marcel.
     <macan@debian.org>
  * Set priority optional
  * Add cmake as build dependency
  * Set format 3.0
  * Add gitignore file
  * Delete substvars file
  * Add gbp.conf file
  * Switch to short debhelper
  * Set compat to 9 to fix hardening
  * Set versions of cmake and debhelper to fix hardening
  * Remove quilt from build dependencies
  * Bump Standards
  * Added dbg package
  * Added zynaddsubfx.manpages file
  * Added zynaddsubfx.install file
  * Added misc:Depends to control file
  * Deleted old patches

  [ Alessio Treglia ]
  * Update copyright file

 -- Jaromír Mikeš <mira.mikes@seznam.cz>  Thu, 23 Aug 2012 14:14:21 +0200

zynaddsubfx (2.4.0-1.2) unstable; urgency=low

  * Non-maintainer upload.
  * debian/patches/{05_partui,06_bankui,09_fluid_1.3}.patch:
    - Fluid 1.3.x no longer produces empty implementations for totally
      empty functions in .fl files, fix FTBFS (Closes: #633478)

 -- Alessio Treglia <alessio@debian.org>  Sun, 21 Aug 2011 10:51:06 +0200

zynaddsubfx (2.4.0-1.1) unstable; urgency=low

  * Non-maintainer upload.
  * Drop LASH support (Closes: #627420):
    - Remove liblash-dev from Build-Depends field.
    - Disable 016_lash.patch patch.

 -- Alessio Treglia <alessio@debian.org>  Thu, 02 Jun 2011 16:28:21 +0200

zynaddsubfx (2.4.0-1) unstable; urgency=low

  * Built with LASH support (Closes: #486243)
  * Build-depends upon libjack-dev (Closes: #527443)
  * Removed patches that were incorporated upstream
  * New upstream release (Closes: #543557)

 -- Eduardo Marcel Maçan <macan@debian.org>  Thu, 20 Aug 2009 00:39:47 -0300

zynaddsubfx (2.2.1-4.1) unstable; urgency=low

  * Non-maintainer upload.
  * Change fftw3-dev build-dep to libfftw3-dev (Closes: #445792)
  * Add quilt patching system
  * Make clean not ignore errors in rules
  * Remove unused debhelper commands in rules
  * debian/menu - Change section Apps/Sound to Sound
  * Add watch file
  * Add Homepage field in control
  * Remove deprecated encoding field from desktop file
  * 01_kfreebsd_fix.patch (Closes: #415675)
    + src/Makefile.inc - fall back to OSS on kfreebsd
  * Move previous source changes to patches
    + 015_oss_and_jack.patch - Use OSS_AND_JACK, not just OSS
    + 02_makefile.patch - Add install target
    + 03_main.patch - Add noui as a parameter to initprogram()
    + 04_virkeyboard.patch - Warning and crash caused in virtual keyboard
      + patch by Guus Sliepen
    + 05_partui.patch - Add PartUI_() function
    + 06_bankui.patch - Add BankProcess_() function
    + 07_ossaudiooutput.patch - Big Endian Fix
    + 08_jackaudiooutput.patch - Add jack ports
    + 09_envelopeparams.patch - Set realtime priority accordingly
    + 10_LFO.patch - Improve frequency randomizer
  * Bump debhelper build-dep and compat to 5
  * Bump standards version to 3.7.3

 -- Barry deFreese <bddebian@comcast.net>  Sun, 16 Dec 2007 17:59:25 -0500

zynaddsubfx (2.2.1-4) unstable; urgency=low

  * Added zlib1g-dev to the build dependencies (closes: #352014) 

 -- macan <macan@debian.org>  Fri, 10 Feb 2006 13:15:38 -0200

zynaddsubfx (2.2.1-3) unstable; urgency=low

  * Patched zynaddsubfx to connect to the default jack output
  * Fixed some compilation warnings and crashing caused by a bug in virtual keyboard, patch by Guus Sliepen (closes: #350152)
  * Updated .desktop file to be XDG compliant. Patch by Free Ekanayaka (closes: #313368)
  * Set realtime priority acordingly. Patch by Ben Hutchings (closes: #314671)

 -- Eduardo Marcel Macan <macan@debian.org>  Wed,  8 Feb 2006 08:50:06 -0200

zynaddsubfx (2.2.1-2.1) unstable; urgency=low

  * Non-maintainer upload.
  * build-depend on libjack0.100.0-dev. Closes: #317229.

 -- Andreas Barth <aba@not.so.argh.org>  Sun, 31 Jul 2005 13:56:28 +0200

zynaddsubfx (2.2.1-2) unstable; urgency=high

  * Added noui as a parameter to initprogram() (closes: #307522)
  * Fixed issues introduced by Brossier's patch (#306824) on little endian architectures (closes: #309401)

 -- Eduardo Marcel Macan <macan@debian.org>  Tue, 17 May 2005 11:29:38 -0300

zynaddsubfx (2.2.1-1) unstable; urgency=low

  * Gave proper credit in this changelog to people who sent patches
  * New upstream release

 -- Eduardo Marcel Macan <macan@debian.org>  Fri, 29 Apr 2005 09:29:12 -0300

zynaddsubfx (2.2.0-2) unstable; urgency=low

  * Fixed endianess problem thanks Paul Brossier (closes: #306824)

 -- Eduardo Marcel Macan <macan@debian.org>  Fri, 29 Apr 2005 09:17:20 -0300

zynaddsubfx (2.2.0-1) unstable; urgency=low

  * New upstream release
  * Fixed XMLWrapper so that saved parameters are loaded properly

 -- Eduardo Marcel Macan <macan@debian.org>  Sat, 23 Apr 2005 08:18:08 -0300

zynaddsubfx (2.1.1-1.1) unstable; urgency=low

  * NMU
  * Changes src/UI/PresetsUI.fl to include FL/fl_ask.H instead of
    FL/fl_ask.h (closes: #304125)
  * Disabled non portable float to int assembly conversion in 


=== debian/control ===
Source: zynaddsubfx
Section: sound
Priority: optional
Maintainer: Debian Multimedia Maintainers <pkg-multimedia-maintainers@lists.alioth.debian.org>
Uploaders:
 Jaromír Mikeš <mira.mikes@seznam.cz>
Build-Depends:
 cmake (>= 2.4),
 debhelper (>= 9.20120417~),
 fluid (>= 1.1.3+1.1.4rc1),
 libasound2-dev (>= 0.9.4) [!kfreebsd-i386 !kfreebsd-amd64 !hurd-i386],
 libfftw3-dev,
 libfltk1.1-dev (>= 1.1.3+1.1.4rc1),
 libjack-dev,
 liblo-dev (>= 0.26~repack),
 dssi-dev (>= 0.9.0),
 libmxml-dev (>= 2.0),
 zlib1g-dev
Standards-Version: 3.9.6
Vcs-Git: git://anonscm.debian.org/pkg-multimedia/zynaddsubfx.git
Vcs-Browser: http://anonscm.debian.org/gitweb/?p=pkg-multimedia/zynaddsubfx.git
Homepage: http://zynaddsubfx.sourceforge.net

Package: zynaddsubfx
Architecture: any
Depends:
 ${misc:Depends},
 ${shlibs:Depends}
Description: Realtime software synthesizer for Linux
 A real-time software synthesizer for Linux and Windows with many
 features, including polyphony, multi-timbral and microtonal
 capabilities. It includes randomness of some parameters, which
 makes warm sounds, like analogue synthesizers.
 It has system/insertion effects too, and much more.

Package: zynaddsubfx-dssi
Architecture: any
Depends:
 ${misc:Depends},
 ${shlibs:Depends}
Description: dssi plugin of zynaddsubfx
 A real-time software synthesizer for Linux and Windows with many
 features, including polyphony, multi-timbral and microtonal
 capabilities. It includes randomness of some parameters, which
 makes warm sounds, like analogue synthesizers.
 It has system/insertion effects too, and much more.
 .
 This package provide dssi plugin of zynaddsubfx.

Package: zynaddsubfx-dbg
Architecture: any
Section: debug
Priority: extra
Depends:
 zynaddsubfx (= ${binary:Version}),
 ${misc:Depends}
Description: Debugging symbols for zynaddsubfx
 A real-time software synthesizer for Linux and Windows with many
 features, including polyphony, multi-timbral and microtonal
 capabilities. It includes randomness of some parameters, which
 makes warm sounds, like analogue synthesizers.
 It has system/insertion effects too, and much more.
 .
 This package contains the debugging symbols.

=== debian/rules ===
#!/usr/bin/make -f

%:
	dh $@ --parallel

override_dh_strip:
	dh_strip --dbg-package=zynaddsubfx-dbg
